﻿ 	  en bit p1.3;
          rw bit p1.2;
          rs bit p1.1;
	  rst bit p1.0
          display equ p2;
	  keyboard equ p0;

          speaker bit P1.4;
          led     bit P1.5;
          open    bit P1.6;
          returnbit EQU R7;
	  
	  SONG	EQU 20H
	  READ    EQU 21H        ; 要求出数据的存储单元
	  XUNHUAN EQU 22H        ; 程序变量单元
	  COUNT   EQU 23H        ; 查找计数器

          ORG 0000h
          LJMP start;
          ORG 000bh;
          LJMP intermit_t0;
          ORG 001bh;
          LJMP intermit_t1;
          ORG 0030h;
start:
	  setb open;//关锁
          MOV sp,#60h;
          lcall sys_initialization;//初始化

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;主程序
main0:    setb open;//关锁
	  lcall strat_display;//显示屏幕

main:
          MOV 52h,#0; 52h判断输入错误次数储存地址
          setb led;
          setb tr0;//开定时器
          lcall key;//开始按键扫描
          cjne a,#'A',next1;//开门模式
          LJMP  set_password;//设置密码模式
next1:    cjne a,#'B',next2;
          LJMP  input_password;
next2:    ajmp main;

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;系统初始化
sys_initialization:
         setb led;
         clr open;
        setb speaker;
;初始化密码
         MOV 34h,#'1';
         MOV 35h,#'2';
         MOV 36h,#'3';
         MOV 37h,#'4';
         MOV 38h,#'5';
         MOV 39h,#'6';
	

         MOV r7,#12;
         MOV r0,#40h;
loop:    MOV @r0,#10h;
         inc r0;
         djnz r7,loop;
 
	 CLR    RST         ; 复位信号控制
    	 LCALL  DELAY       ; 延时
    	 SETB   RST         ; 释放复位
    	 LCALL  ST12864_INT ; 初始化12864液晶
         ;液晶初始化完毕

         MOV r4,#10;
         MOV tmod,#11h;
         MOV th0,#3ch;
         MOV tl0,#0b0h;
         setb ea;
         setb et0;
         ;定时器T0，0.5S定时中断初始化完毕

         ret;
         ;系统初始化完毕

;;;;;;;;;;;;;;;;;;;;;;中断服务程序 定时器中断
intermit_t0:;0.5s
          push acc;
          push psw;
          MOV th0,#3ch;
          MOV tl0,#0b0h;
          djnz r4,return;
          cpl led;
          MOV r4,#10;
return:   pop psw;
          pop acc;
          reti;

intermit_t1:;0.25s
          push acc;
          push psw;
          MOV th1,#9eh;
          MOV tl1,#58h;
          djnz r4,return_t1;
          cpl led;
          cpl speaker;
          MOV r4,#10;
return_t1:pop psw;
          pop acc;
          reti;

;;;;;;;;;;;;;;;;;;;;;;;;;;;;键盘扫描
key:     call ks;
         jnz k1;
         jmp key;

k1:
         call delay;
         call ks;
         jnz k2;
         jmp key;

k2:
         clr tr0;//关定时器
         clr led;
	 MOV r2,#07fh;
         MOV r6,#00h;//判断键值对应数组指针

k3:      MOV a,r2;
         MOV keyboard,a;//将P2.0为低电平，找IO
         MOV a,keyboard;
         jb acc.0,l1;//判断是否为keyboard.0被下拉，
         MOV a,#0;
         LJMP lk;

l1:      jb acc.1,l2;//判断是否为keyboard.1被下拉，
         MOV a,#4;
         LJMP lk;

l2:      jb acc.2,l3;//判断是否为keyboard.2被下拉，
         MOV a,#8;
         LJMP lk;

l3:      jb acc.3,next_key;//判断是否为keyboard.3被下拉，
         MOV a,#12;

lk:      add a,r6;
         MOV r6,a;

k4:      call ks;
         jnz k4;
         MOV a,r6;
         MOV dptr,#table0;
         MOVc a,@a+dptr;
         MOV 50h,a    ;//查表取值存入50h,保护键值
         ret;

next_key: inc r6;//进入下一数组
          MOV a,r2;
          jnb acc.3,key;//如果不是没有都地位口都扫描完
          rr a;
          MOV r2,a;//设置下一个地位口为低电平
          jmp k3;//回到扫描

;;;;;;;;;;;;;;;;;;;;;;;;;;找到被拉低的高位IO口 判断有按键按下
ks:      
	 MOV keyboard,#00fh;
         MOV a,keyboard;
         xrl a,#00fh;
         ret;

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;设置密码程序
set_password:
         call clear_display;//清屏
	 MOV DPTR,#TABLE_INPUT_KEY_C;初始化字符串输入
	 LCALL  HANZI_WRITE

         MOV r0,#40h;//存数据输入起始位置
	 MOV returnbit,#00H
         call password;//输入密码
         CJNE returnbit,#0,set_password;//清除输入区
         ;//先输入原密码完毕

         MOV r5,#6;//密码串个数
         MOV r0,#40h;//输入的密码地址
         MOV r1,#34h;//密码存储地址
	 ;MOV R7,#1
input_compere:;//比较输入输出
	 ;INC R7
         MOV a,@r0;
         xrl a,@r1;
         jnz input_error;//判断是否相等
         inc r0;
         inc r1;//判断下一位
         nop;
         nop;
         djnz r5,input_compere;//判断五位
         ;验证输入密码完毕
         jmp set_password0;//设置密码

input_error:;//输入错误
         clr speaker;
         clr led;

         call clear_display;//清屏
	 MOV DPTR,#TABLE_ERROR;字符串输入
	 LCALL  HANZI_WRITE
	 
         call delay1_5s;

         setb speaker;
         setb led;

         inc 52h;
         MOV a,52h;
         cjne a,#3,set_password;
	 call delay1_5s
	 jmp main0

set_password0:
         call clear_display;
	 MOV DPTR,#TABLE_NEW_KEY;字符串输入
	 LCALL  HANZI_WRITE

         MOV r0,#40h;
         call password;

	 CJNE returnbit,#0,set_password
         ;//第一次输入新密码完毕

         call clear_display;
	 MOV DPTR,#TABLE_AGAIN;字符串输入
	 LCALL  HANZI_WRITE
         call delay1_5s;
         ;//显示再次输入新密码完毕

         call clear_display;
	 MOV DPTR,#TABLE_NEW_KEY;字符串输入
	 LCALL  HANZI_WRITE

         MOV r0,#46h;
         call password;
	 CJNE returnbit,#0,set_password
         ;//第二次输入新密码完毕

         MOV r5,#6;
         MOV r0,#40h;
         MOV r1,#46h;
set_compere:;//判断两新密码是否相同
         MOV a,@r0;
         xrl a,@r1;
         jnz set_error;
         inc r0;
         inc r1;
         djnz r5,set_compere;

         MOV 34h,40h;
         MOV 35h,41h;
         MOV 36h,42h;
         MOV 37h,43h;
         MOV 38h,44h;
         MOV 39h,45h;
         ;//存入新密码完毕

         jmp main0;
         ;//设置新密码成功，返回主程序

set_error:
         clr speaker;
         clr led;

         call clear_display;
	 MOV DPTR,#TABLE_ERROR;字符串输入
	 LCALL  HANZI_WRITE
         call delay1_5s;

         setb speaker;
         setb led;

         LJMP set_password0;
         ;前后两次输入新密码不一致，返回重设
;;;;;;;;;;;;;;;;;;输入密码开锁程序
input_password:
         call clear_display;
	 MOV DPTR,#TABLE_INPUT_KEY;字符串输入
	 LCALL  HANZI_WRITE

         MOV r0,#40h;
         call password;
         ;//判断清屏
	 CJNE returnbit,#0,input_password
         ;输入原密码完毕

         MOV r5,#6;
         MOV r0,#40h;
         MOV r1,#34h;
input_compere0:;//对比
         MOV a,@r0;
         xrl a,@r1;
         jnz input_error22;
         inc r0;
         inc r1;
         nop;
         nop;
         djnz r5,input_compere0;
         ;//验证输入密码完毕
         jmp display_right;//输入正确

input_error22:
         clr speaker;
         clr led;

         call clear_display;

	 MOV DPTR,#TABLE_ERROR;字符串输入
	 LCALL  HANZI_WRITE

         call delay1_5s;

         setb speaker;
         setb led;

         inc 52h;
         MOV a,52h;
         cjne a,#3,input_password;
	 call delay1_5s
	 jmp main0
display_right:
         call clear_display;
         ; 显示输入密码正确，锁已经打开	
	 MOV DPTR,#TABLE_OPEN;字符串输入
	 LCALL  HANZI_WRITE
         clr open;   开锁
next_key1:call key;
          nop;
          nop;
          cjne a,#'F',next_key1;//不为返回时重复执行
          setb open;   按//下关锁键，关锁
          jmp main0;;   返回主程序


;;;;;;;;;;;;;;;;;;;;;;;;
strat_display:;界面显示

	 MOV DPTR,#TABLE_INIT;初始化字符串输入
	 LCALL  HANZI_WRITE
	 RET

clear_display:

	 MOV   SONG, #01H   ; 清除显示屏幕控制字
    	 LCALL SEND_ML      ; 将DDRAM填满20H（空格）
    	 MOV   SONG, #06H   ; 设定光标移动控制字（图形不移动，光标右移）
    	 LCALL SEND_ML      
    	 MOV   SONG, #0CH   ; 设定显示状态控制字（开显示，无光标，无空白）
    	 LCALL SEND_ML      
    	 RET                

password:;//输入密码函数
         MOV r5,#6;

	 MOV r1,#088h;
	 MOV SONG,R1      ; 写汉字子程序
	 LCALL SEND_ML      ; 设定 DDRAM 地址（第 1 行），AC=0
loop1:   call key;//按键扫描
         nop;
         nop;
         cjne a,#'C',next_to;//清除
         MOV returnbit,#1;
         jmp endt;
next_to:
         MOV a,50h;
         MOV @r0,a;//存入数据
	 MOV SONG,#'*';松子
    	 LCALL SEND_SJ;鞋子
         inc r1;
         inc r0;
         djnz r5,loop1;//输入六个数据
endt:    ret;

;;;;;;;;;;;;;;;;;;;;;;;;;延时程序

delay2_5s:   push 07h;
             push 02h;
             push 03h;
	     push 04h;
	     mov r4,#8
delaa:      MOV r7,#180;
del222s:      MOV r3,#0;
del111s:      MOV r2,#0;
             djnz r2,$;
             djnz r3,del111s;
             djnz r7,del222s;
	     djnz r4,delaa
	     pop 04h;
             pop 03h;
             pop 02h;
             pop 07h;
             ret;

delay1_5s:   
	     push 07h;
             push 02h;
             push 03h;
             MOV r7,#15;
del22s:      MOV r3,#0;
del11s:      MOV r2,#0;
             djnz r2,$;
             djnz r3,del11s;
             djnz r7,del22s;
             pop 03h;
             pop 02h;
             pop 07h;
             ret;

delay0_1s:   push 02h;
             push 03h;
             MOV r3,#0;
del21s:      MOV r2,#0;
             nop;
             nop;
             djnz r2,$;
             djnz r3,del21s;
             pop 03h;
             pop 02h;
             ret;


delay:   push 07h;
         push 06h;
         MOV r7,#10;
d1:      MOV r6,#248;
         nop
         nop
         djnz r6,$;
         djnz r7,d1;
         pop 06h;
         pop 07h;
         ret
;;;;;;;;;;;;;;;;;;;;;;;;

TABLE:  
    DB     "1111大范围工具学"  ; 汉字数据表
    DB     "1234511111111111"   ; 日期数据：18年03月15日
TABLE_INIT:
    DB	   "OPETATE PASSWORD"
    DB	   "CHANGE  OR  OPEN"
TABLE_INPUT_KEY:
    DB	   "Input The Key:  "
    DB	   "                "
TABLE_INPUT_KEY_C:
DB	   "Input The Key: C"
DB	   "                "
TABLE_ERROR:
    DB	   "     ERROR!!    "
    DB     "                "
TABLE_NEW_KEY:
    DB	   "  INPUT NEW KEY "
    DB     "                "
TABLE_AGAIN:
    DB	   " INPUT KEY AGAIN"
    DB 	   "                "
TABLE_OPEN:
    DB	   " LOCK IS OPENED "
    DB     "                "
table0:
    db  'C','B','0','A';
    db  'D','9','8','7';
    db  'E','6','5','4';
    db  'F','3','2','1';

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
DELAY9:  
    PUSH  00H          ; 延时子程序
    PUSH  01H          
    MOV   R0, #00H     
DELAY1: 
    MOV   R1, #00H     
    DJNZ  R1, $        
    DJNZ  R0, DELAY1   
    POP   01H          
    POP   00H          
    RET                

ST12864_INT:           ; 模块初始化程序
    MOV   SONG, #30H   ; 基本指令集操作控制字（00110000B）
    LCALL SEND_ML      
    MOV   SONG, #01H   ; 清除显示屏幕控制字
    LCALL SEND_ML      ; 将DDRAM填满20H（空格）
    MOV   SONG, #06H   ; 设定光标移动控制字（图形不移动，光标右移）
    LCALL SEND_ML      
    MOV   SONG, #0CH   ; 设定显示状态控制字（开显示，无光标，无空白）
    LCALL SEND_ML      
    RET                

SEND_ML:               ; 送命令子程序
    LCALL CHK_BUSY     ; 检测12864忙状态
    MOV   P2, SONG     ; 数据写入12864数据口
    CLR   RS           ; RS=0选择指令寄存器
    CLR   RW           ; RW=0写操作
    SETB  EN           ; 使能信号
    LCALL DELAY9
    CLR   EN           ; 产生下降沿执行命令
    RET                ; 第4章 MCS-51（AT86C51）单片机基本结构及典型接口实验




CHK_BUSY:
    MOV P2,#0FFH       ; 查询状态子程序
    CLR RS             ; 这里写1是为单片机输入做准备
    SETB RW
    SETB EN
LOOP6: 
    MOV A,P2           ; 与下面的 CLR EN 指令配合，让使能信号产生下降沿
    JB P2.7,LOOP6
    CLR EN             ; 检测试指令，if P2.7=1 则“忙”，等待
    RET

HANZI_WRITE:
    MOV SONG,#80H      ; 写汉字子程序
    LCALL SEND_ML      ; 设定 DDRAM 地址（第 1 行），AC=0
    MOV XUNHUAN,#32    ; 共 32 个字节（16 个字）
    ;MOV DPTR,#TABLE
    MOV A,#00H
    MOV COUNT,#00H
LOOP9: 
    MOVC A,@A+DPTR
    MOV SONG,A
    LCALL SEND_SJ;鞋子
    INC COUNT
    MOV A,COUNT
    DJNZ XUNHUAN,LOOP9
    RET

SEND_SJ:
    LCALL CHK_BUSY
    MOV P2,SONG
    SETB RS
    CLR RW
    SETB EN
    CLR EN
    RET
END
